<template>
  <gp-timeline-entry icon="observations"
                     :subject="subjectProperties.name"
                     :subject-icon="subjectProperties.icon"
                     :title="observation.title"
                     :hide-icon="hideIcon"
                     :opened="opened"
                     :comments-subject="observation">
    <template v-if="showActions && (editable || destroyable)" #actions>
      <rui-button v-if="editable"
                  size="small"
                  icon="pencil"
                  :title="$t('generic.edit')"
                  @click="editObservation" />
      <rui-button v-if="destroyable"
                  size="small"
                  icon="trash"
                  variant="destructive"
                  :title="$t('generic.destroy')"
                  @click="destroyObservation" />
    </template>

    <div v-if="observation.content" class="_writing -mbd">{{ observation.content }}</div>

    <rui-thumbnails v-if="observation.pictures.length > 0"
                    :list="observation.pictures"
                    :class="observation.content ? '-mtm' : ''"
                    @open="handleImageOpen" />
  </gp-timeline-entry>
</template>
<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiThumbnails from '@experiments-labs/rise_ui/src/components/DataDisplay/Thumbnails/Thumbnails.vue'
import GpTimelineEntry from '../TimelineEntry/TimelineEntry.vue'

import Observation from '@/vue/classes/models/Observation'
import { subjectProperties } from '@/vue/tools/SubjectProperties'
import Toaster from '@/vue/tools/Toaster'

/**
 * Displays an observation in a Timeline
 *
 * Due to parts of it overflowing, it should not be used outside a Timeline.
 *
 * @noPlayground
 */
export default {
  name: 'GpObservationTimelineEntry',
  emits: [
    /**
     * An image has been clicked on
     *
     * @param {string} image_url URL of the clicked image
     */
    'show-image',
  ],
  components: { GpTimelineEntry, RuiThumbnails, RuiButton },
  props: {
    /** Observation to display */
    observation: { required: true, type: Observation },
    /**
     * Whether to display edition buttons, overriding the current user ownership.
     *
     * Only make observations editable in the context of a map where ownership can be verified.
     */
    showActions: { required: false, type: Boolean, default: false },
    /** Whether to hide the big icon */
    hideIcon: { required: false, type: Boolean, default: false },
    /** Whether the entry is opened on load */
    opened: { required: false, type: Boolean, default: false },
  },
  computed: {
    subjectProperties () {
      return subjectProperties(this.observation.subject)
    },
    editable () { return this.$store.getters.account?.id === this.$props.observation.userId },
    destroyable () { return this.editable || this.$store.getters.isMapOwner },
  },
  methods: {
    handleImageOpen (url) { this.$emit('show-image', url) },
    editObservation () {
      this.$emitBus('show-observation-form', this.observation)
    },
    destroyObservation () {
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.observation.destroy_confirmation_title'),
        message: this.$t('js.observation.destroy_confirmation'),
        callback: () => {
          this.$store.dispatch('destroyObservation', this.observation.id)
            .then(() => { Toaster.success(this.$t('js.observation.successfully_destroyed')) })
            .catch(() => { Toaster.error(this.$t('js.observation.failed_to_destroy')) })
        },
      })
    },
  },
}
</script>
